/// しおりリスト画面 - SCRSLS0100

/// <reference path="../common/js/avweb.js" />

/// <reference path="../common/js/screenLock.js" />

/// <reference path="../common/js/common.js" />

/// <reference path="../common/js/i18n.js" />

/// <reference path="../common/js/jquery-1.8.1.min.js" />

/// <reference path="../common/js/jquery-ui-1.8.23.custom.min.js" />

/// <reference path="../common/js/jquery.toastmessage.js" />

/// <reference path="../common/js/pageViewer.js" />

/// <reference path="init.js" />

//var TotalThread = 0;

// Init function of page
$(document).ready(function () {

    // Synchronize bookmarks with server
    SyncContent();

    if (!avwCheckLogin(ScreenIds.Login)) return;
    
    LockScreen();
    
    document.title = i18nText('dspShiori') + ' | ' + i18nText('sysAppTitle');

    // Set bookmark screen
    ClientData.BookmarkScreen(ScreenIds.BookmarkList);

    $("#dspDelete").click(dspDelete_Click);
    $("#dspDelete1").click(dspDelete1_Click);
    $("#dspCancel").click(dspCancel_Click);
    $("#dspConfirmOK").click(dspConfirmOK_Click);

    ClearGrid();

    if (ClientData.BookMarkData().length == 0) {
        // Show error
        $("#msgShioriNotExists").show();
        $("#dspDelete").hide();
        $("#dspDelete1").hide();
    }
    else {
        $("#msgShioriNotExists").hide();
        $("#dspDelete").show();
        $("#dspDelete1").show();
    }

    // Show book in local storage
    //ShowBookmark();

    $("a[name='dspRead']").unbind('click');
    $("a[name='dspRead']").click(dspRead_Click);

    HideSorting();

    // Default sort is タイトル名, default is asc
    ClientData.sortOpt_searchDivision(1);
    ClientData.sortOpt_sortType(2);
    dspTitleNm_Click();
});

/*
----------------------------------------------------------------------------
Event groups [start]
----------------------------------------------------------------------------
*/

function dspTitleNm_Click() {
    
    var isAsc = false;
    if (ClientData.sortOpt_searchDivision() == 1) { // Name
        if (ClientData.sortOpt_sortType() == 1) {   // ASC
            isAsc = false;
            ClientData.sortOpt_sortType(2);
        }
        else {
            isAsc = true;
            ClientData.sortOpt_sortType(1);
        }
    }
    else {
        ClientData.sortOpt_searchDivision(1);
        ClientData.sortOpt_sortType(1); // default is asc
        isAsc = true;
    }
    
    SortTitleName(isAsc);
    $("#dspTitleNm").addClass("active_tops");        
    $("#dspTitleNmKn").removeClass("active_tops");    
    $("#dspPubDt").removeClass("active_tops");
    
}
function dspTitleNmKn_Click() {
    var isAsc = false;
    if (ClientData.sortOpt_searchDivision() == 2) { // Kana
        if (ClientData.sortOpt_sortType() == 1) {   // ASC
            isAsc = false;
            ClientData.sortOpt_sortType(2);
        }
        else {
            isAsc = true;
            ClientData.sortOpt_sortType(1);
        }
    }
    else {
        ClientData.sortOpt_searchDivision(2); // Kana
        ClientData.sortOpt_sortType(1); // default is asc
        isAsc = true;
    }

    SortTitleNameKana(isAsc);

    $("#dspTitleNm").removeClass("active_tops");        
    $("#dspTitleNmKn").addClass("active_tops");    
    $("#dspPubDt").removeClass("active_tops");
}
function dspPubDt_Click() {
    var isAsc = false;
    if (ClientData.sortOpt_searchDivision() == 3) { // Publish date
        if (ClientData.sortOpt_sortType() == 1) {   // ASC
            isAsc = false;
            ClientData.sortOpt_sortType(2);
        }
        else {
            isAsc = true;
            ClientData.sortOpt_sortType(1);
        }
    }
    else {
        ClientData.sortOpt_searchDivision(3); // Kana
        ClientData.sortOpt_sortType(1); // default is asc
        isAsc = true;
    }

    SortPubDate(isAsc);

    $("#dspTitleNm").removeClass("active_tops");        
    $("#dspTitleNmKn").removeClass("active_tops");    
    $("#dspPubDt").addClass("active_tops");
}

// Event of each button [読む]
function dspRead_Click() {     	    
    var jsondata = $(this).attr("value");       
    var data = JSON.parse(jsondata);             
    ClientData.contentInfo_contentId(data.contentid);
    ClientData.bookmark_contentNo(data.contentid);
    ClientData.bookmark_pageNo(data.pageNo);

    ClientData.IsRefresh(false);
    avwScreenMove(ScreenIds.ContentView);
}

// Cancel dialog of deleting
function dspCancel_Click() {
    // Close dialog
    //$('#dlgConfirm').dialog('close');
    $("#delete_shiori").hide();
    unlockLayout();
}
// Process deleting
function dspConfirmOK_Click() {
    // --------------------------------
    // Process deleting [start]
    // --------------------------------
    
    // Get selected bookmarks
    var arrSelectedBookmarks = $("input[name='chkDelete']:checked");
    $.each(arrSelectedBookmarks, function () {
        // Delete selected items on layout

        var contentid = JSON.parse(this.value).contentid;
        var pageNo = JSON.parse(this.value).pageNo;

        $(this).parent().parent().parent().remove();

        // Remove from ClientData
        var bm = ClientData.BookMarkData();

        for (var nIndex = bm.length - 1; nIndex >= 0; nIndex--) {
            if (bm[nIndex].contentid == contentid && bm[nIndex].pageNo == pageNo) {
                bm.splice(nIndex, 1);
                ClientData.isChangedBookmark(true);
            }
        }
        ClientData.BookMarkData(bm);

        if (ClientData.BookMarkData().length == 0) {
            // Show error
            $("#msgShioriNotExists").show();
            $("#dspDelete").hide();
            $("#dspDelete1").hide();
        }
    });
    
    // --------------------------------
    // Process deleting [ end ]
    // --------------------------------

    $("#delete_shiori").hide();
    unlockLayout();
}

function dspDelete1_Click() {
    dspDelete_Click();
}

function dspDelete_Click() {		
    if ($("input[name='chkDelete']:checked").length > 0) {
    	lockLayout();
    	$("#delete_shiori").show();
    	$("#delete_shiori").center();    	
        //$('#dlgConfirm').dialog('open');
        //$(".ui-dialog-titlebar").hide();
    }    
}

// Show detail content
function ShowBookmark() {
    var hasMemo = false;
    var hasMarking = false;
    var contentid = "";
    var pageNo = 0;

    if (ClientData.BookMarkData().length > 0) {
        $("#dspDelete").show();
        $("#dspDelete1").show();
    }
    //TotalThread = ClientData.BookMarkData().length;
    for (var nIndex = ClientData.BookMarkData().length - 1; nIndex >= 0 ; nIndex--) {
        hasMarking = false;
        hasMemo = false;

        contentid = ClientData.BookMarkData()[nIndex].contentid;
        pageNo = ClientData.BookMarkData()[nIndex].pageNo;

        // Check if contentid has marking
        for (var nIndex1 = 0; nIndex1 < ClientData.MarkingData().length; nIndex1++) {

            if (ClientData.MarkingData()[nIndex1].contentid == contentid
               && ClientData.MarkingData()[nIndex1].pageNo == pageNo) {
                hasMarking = true;
            }
        }

        // Check if contentid has memo
        for (var nIndex1 = 0; nIndex1 < ClientData.MemoData().length; nIndex1++) {

            if (ClientData.MemoData()[nIndex1].contentid == contentid
               && ClientData.MemoData()[nIndex1].pageNo == pageNo) {
                hasMemo = true;
            }
        }
//        if (IsErrorPage(contentid, pageNo)) {
//            insertRowError(contentid, htmlEncode(ClientData.BookMarkData()[nIndex].contentTitle), pageNo);
//        }
//        else {
//            callApi.execute(contentid, ClientData.userInfo_sid(), pageNo, hasMemo, hasMarking, htmlEncode(ClientData.BookMarkData()[nIndex].contentTitle), nIndex);
//        }

        callApi.execute(contentid, ClientData.userInfo_sid(), pageNo, hasMemo, hasMarking, htmlEncode(ClientData.BookMarkData()[nIndex].contentTitle), nIndex);

    }
    $("a[name='dspRead']").unbind('click');
    $("a[name='dspRead']").click(dspRead_Click);
}
// Hide all sorting symbol
function HideSorting() {
    $("#txtTitleNmAsc").hide();
    $("#txtTitleNmDesc").hide();
    $("#txtTitleNmKnAsc").hide();
    $("#txtTitleNmKnDesc").hide();
    $("#txtPubDtAsc").hide();
    $("#txtPubDtDesc").hide();
}
// Sort by title name
function SortTitleName(isAsc) {
    HideSorting();
    
    if (isAsc) {
        $("#txtTitleNmAsc").show();        
    }
    else {
        $("#txtTitleNmDesc").show();
    }

    var arrSource = ClientData.BookMarkData();
    var arrTarget = [];
    var strTemp = "";
    var nTempIndex = 0;
    var isStop = false;
    while (!isStop) {
        if (arrSource.length > 0) {
            strTemp = "";
            // Lookup min item
            for (var nIndex = 0; nIndex < arrSource.length; nIndex++) {
                if (strTemp == "") {
                    strTemp = arrSource[nIndex].contentTitle;
                    nTempIndex = nIndex;
                }
                else {
                    // ASC
                    if (isAsc) {
                        if (arrSource[nIndex].contentTitle < strTemp) {
                            strTemp = arrSource[nIndex].contentTitle;
                            nTempIndex = nIndex;
                        }
                    }
                    else {
                        if (arrSource[nIndex].contentTitle > strTemp) {
                            strTemp = arrSource[nIndex].contentTitle;
                            nTempIndex = nIndex;
                        }
                    }
                }
            }
            // Add to target array
            arrTarget.push(arrSource[nTempIndex]);
            // Remove min item from source array
            arrSource.splice(nTempIndex, 1);
        }
        else {
            isStop = true;
        }
    }
    ClearGrid();
    ClientData.BookMarkData(arrTarget);
    ShowBookmark();
}
// Clear all rows of grid
function ClearGrid() {

    var arrSelectedBookmarks = $("input[name='chkDelete']");
    $.each(arrSelectedBookmarks, function () {
        $(this).parent().parent().parent().remove();
    });
    
    //if (TotalThread == 0) {
        //$('#grid tr').remove();
    //}
    
    // var arrSelectedBookmarks = $("input[name='chkDelete']");

    
}
// Sort by title name kana
function SortTitleNameKana(isAsc) {
    HideSorting();

    if (isAsc) {
        $("#txtTitleNmKnAsc").show();               
    }
    else {
        $("#txtTitleNmKnDesc").show();        
    }

    var arrSource = ClientData.BookMarkData();
    var arrTarget = [];
    var strTemp = "";
    var nTempIndex = 0;
    var isStop = false;
    while (!isStop) {
        if (arrSource.length > 0) {
            strTemp = "";
            // Lookup min item
            for (var nIndex = 0; nIndex < arrSource.length; nIndex++) {
                if (strTemp == "") {
                    strTemp = arrSource[nIndex].contentTitleKana;
                    nTempIndex = nIndex;
                }
                else {
                    // ASC
                    if (isAsc) {
                        if (arrSource[nIndex].contentTitleKana < strTemp) {
                            strTemp = arrSource[nIndex].contentTitleKana;
                            nTempIndex = nIndex;
                        }
                    }
                    else {
                        if (arrSource[nIndex].contentTitleKana > strTemp) {
                            strTemp = arrSource[nIndex].contentTitleKana;
                            nTempIndex = nIndex;
                        }
                    }
                }
            }
            // Add to target array
            arrTarget.push(arrSource[nTempIndex]);
            // Remove min item from source array
            arrSource.splice(nTempIndex, 1);
        }
        else {
            isStop = true;
        }
    }
    ClearGrid();
    ClientData.BookMarkData(arrTarget);
    ShowBookmark();
}
// Sort by publish date
function SortPubDate(isAsc) {
    HideSorting();

    if (isAsc) {
        $("#txtPubDtAsc").show();
    }
    else {
        $("#txtPubDtDesc").show();
    }

    var arrSource = ClientData.BookMarkData();
    var arrTarget = [];
    var dateTemp = undefined;
    var nTempIndex = 0;
    var isStop = false;
    while (!isStop) {
        if (arrSource.length > 0) {
            dateTemp = undefined;
            // Lookup min item
            for (var nIndex = 0; nIndex < arrSource.length; nIndex++) {
                if (dateTemp == undefined) {
                    dateTemp = arrSource[nIndex].registerDate;
                    nTempIndex = nIndex;
                }
                else {
                    // ASC
                    if (isAsc) {
                        if (arrSource[nIndex].registerDate < dateTemp) {
                            dateTemp = arrSource[nIndex].registerDate;
                            nTempIndex = nIndex;
                        }
                    }
                    else {
                        if (arrSource[nIndex].registerDate > dateTemp) {
                            dateTemp = arrSource[nIndex].registerDate;
                            nTempIndex = nIndex;
                        }
                    }
                }
            }
            // Add to target array
            arrTarget.push(arrSource[nTempIndex]);
            // Remove min item from source array
            arrSource.splice(nTempIndex, 1);
        }
        else {
            isStop = true;
        }
    }
    ClearGrid();
    ClientData.BookMarkData(arrTarget);
    ShowBookmark();
}
/*
Update information of specified bookmark
*/
function UpdateBookmark(contentid, pageNo, contentTitle, contentTitleKana) {
    var arrBookmarks = ClientData.BookMarkData();

    for (var nIndex = 0; nIndex < arrBookmarks.length; nIndex++) {
        if (contentid == arrBookmarks[nIndex].contentid && pageNo == arrBookmarks[nIndex].pageNo) {
            if (contentTitle != null && contentTitle != undefined) {
                arrBookmarks[nIndex].contentTitle = contentTitle;
            }
            if (contentTitleKana != null && contentTitleKana != undefined) {
                arrBookmarks[nIndex].contentTitleKana = contentTitleKana;
            }
            break;
        }
    }
    // Set bookmark back to client data
    ClientData.BookMarkData(arrBookmarks);
}

// Call API controller
var callApi = {
    contentid: "",
    pageNo: 0,
    execute: function (contentid, sid, pageNo, hasMemo, hasMarking, contentTitle, index) {
        this.contentid = contentid;
        this.pageNo = pageNo;
        avwCmsApiSync(ClientData.userInfo_accountPath(), "webContentPage", "GET", { contentId: contentid, sid: sid, pageNos: pageNo, thumbnailFlg: 1 },
                function (data) {
                    if (data.pages.length == 0) {
                        // Page does not exist
                        AddErrorPage(contentid, pageNo);
                        insertRowError(contentid, htmlEncode(contentTitle), pageNo);
                    }
                    else {
                        // Update local title to be equal to server
                        UpdateBookmark(contentid, pageNo, data.contentTitle, data.contentTitleKana);
                        contentTitle = data.contentTitle;

                        // Insert to grid
                        insertRow(contentid, "data:image/jpeg;base64," + data.pages[0].pageThumbnail, htmlEncode(contentTitle), data.pages[0].pageText, pageNo, hasMemo, hasMarking, index);
                    }
                    /*
                    // Update local title to be equal to server
                    UpdateBookmark(contentid, pageNo, data.contentTitle, data.contentTitleKana);
                    contentTitle = data.contentTitle;

                    for (var nIndex2 = 0; nIndex2 < data.pages.length; nIndex2++) {

                    if (pageNo == data.pages[nIndex2].pageNo) {
                    // Update bookmark 

                    // Insert to grid
                    insertRow(contentid, "data:image/jpeg;base64," + data.pages[nIndex2].pageThumbnail, htmlEncode(contentTitle), data.pages[nIndex2].pageText, pageNo, hasMemo, hasMarking, index);
                    //TotalThread--;
                    break;
                    }
                    }
                    $("a[name='dspRead']").unbind('click');
                    $("a[name='dspRead']").click(dspRead_Click);
                    */
                },
                null
        );
    }
}

/*
 Insert error row
*/
function insertRowError(contentid, pageTitle, pageNo) {

    var newRow = "";
    
//    newRow += "<tr>";
//    newRow += "<td id='check'>";
//    newRow += "<input type='checkbox' name='chkDelete' value='{\"contentid\":" + contentid + ", \"pageNo\":" + pageNo + "}'/>";
//    newRow += "</td>";
//    newRow += "<td colspan='2'>";
//    newRow += '<div><label id="Label1">' + pageTitle + '</label></div>';
//    newRow += "<label class='lang bookmarl_deleted' lang='msgShioriDeleted'>" + i18nText('msgShioriDeleted') + "</label>";
//    newRow += "</td>";

//    newRow += "<td>";
//    newRow += "</td>";
//    newRow += "<td>";
//    
//    newRow += "</td>";
//    newRow += "<td>";
//    newRow += "</td>";
//    newRow += "</tr>";

    //    $('#grid').append(newRow);
    newRow += "<section>";
    newRow += "     <div class='cnt_section'>";
    newRow += "         <div class='check'>";
    newRow += "             <input type='checkbox' name='chkDelete' value='{\"contentid\":" + contentid + ", \"pageNo\":" + pageNo + "}'/>";
    newRow += "         </div>";
    newRow += "     <div class='text'>";
    newRow += '         <label class="name" style="color: #2D83DA;">' + truncate(pageTitle, 20) + '</label>';
    newRow += '         <div class="info">';
    newRow += "                 <label class='lang name' lang='msgShioriDeleted'>" + i18nText('msgShioriDeleted') + "</label>";
    
    newRow += "         </div>";
    newRow += "     </div>";
    
    newRow += "</section>";
    $('#pnlTop').after(newRow);
}


// Insert row to grid       
function insertRow(contentid, pageThumbnail, pageTitle, pageText, pageNo, hasMemo, hasMarking, index) {	
    var imgMarkingHide = '<img style="visibility:hidden" class="pen" alt="" src="./img/list/pic_2.png" />';
    var imgMemoHide = '<img style="visibility:hidden" class="sticker" alt="" src="./img/list/pic_1.png" />';
    var imgMarking = '<img class="pen" alt="" src="./img/list/pic_2.png" />';
    var imgMemo = '<img class="sticker" alt="" src="./img/list/pic_1.png" />';
    var newRow = "";
    newRow += "<section>";
    newRow += "<div class='cnt_section'>";
    newRow += "<div class='check'>";
    newRow += "<input type='checkbox' name='chkDelete' value='{\"contentid\":" + contentid + ", \"pageNo\":" + pageNo + ", \"index\": " + index+ "}'/>";
    newRow += "</div>";    
    newRow += "<a class='img'>";
    newRow += '<img id="pageImg' + contentid + '" src="' + pageThumbnail + '" width="160" height="120" style="display:none;">';
    newRow += '<img id="loadingIcon' + contentid + "_" + pageNo + '" src="./img/data_loading.gif" height="25px" width="25px" style="padding: 46px; "/>';
    newRow += "</a>";
    newRow += "<div class='text'>";    
    newRow += '<label id="Label1" class="name" style="color: #2D83DA;">' + truncate(pageTitle, 20) + '</label>';
    newRow += '<div class="info">';
    newRow += '<ul class="date">';
    newRow += '<li><label id="Label2" class="lang" lang="txtPage">' + i18nText('txtPage') + '</label><label id="Label3">' + pageNo + '</label></li>';
    var contentText = htmlEncode(getLines(pageText, 3));
    
    newRow += '<li><label id="Label1">' + truncate(contentText, 80) + '</label></li>'         
    newRow += "</ul>";

	newRow += '<ul class="pic"  style="align:right">';
	newRow += "<li>";

    //Resize Image
    var imgTemp = new Image();

    imgTemp.onload = function () {

        if (imgTemp.width > imgTemp.height) {

            $("img#pageImg" + contentid).attr('height', '');
            $("img#pageImg" + contentid).removeAttr('height');
            $("img#pageImg" + contentid).attr('width', '120');
            var realHeight = (120 * imgTemp.height) / imgTemp.width;
            $("img#pageImg" + contentid).css('padding-top', (120 - realHeight) / 2 + 'px');
        }
        else {
            $("img#pageImg" + contentid).attr('width', '');
            $("img#pageImg" + contentid).removeAttr('width');
            $("img#pageImg" + contentid).attr('height', '120');
            $("img#pageImg" + contentid).css('padding-top', '0px');
        }
        
        $("#loadingIcon" + contentid + "_" + pageNo).fadeOut('slow', function () {
            $("img#pageImg" + contentid).fadeIn('slow');
        });
    };
    	
    imgTemp.src = pageThumbnail;
	

	if (hasMemo) {
	    newRow += imgMemo;
	}
	else {
	    newRow += imgMemoHide;
	}
    newRow += "</li>";
    newRow += "<li>";
    
    if (hasMarking) {
        newRow += imgMarking;
    }
    else {
        newRow += imgMarkingHide;
    }
    newRow += "</li>";
    newRow += "<li><a class='read lang' name='dspRead' value='{\"contentid\":\"" + contentid + "\", \"pageNo\":\"" + pageNo + "\"}' lang='txtRead'>" + i18nText('txtRead') + "</a></li>";  	
    newRow += "</ul>";
    newRow += "</div>";
    newRow += "</div>";
    //newRow += "<button class='button lang' name='dspRead' value='{\"contentid\":" + contentid + ", \"pageNo\":" + pageNo + "}' lang='dspRead'>読む</button>";
    newRow += "</div>";
    newRow += "</section>";

    //var chks = $("input[name='chkDelete']");
    $('#pnlTop').after(newRow);
    /*
    if (chks.length == 0) {
        // Add first row
        $('#grid').append(newRow);
    }
    else {
        // From second row
        for (var nIndex = 0; nIndex < chks.length; nIndex++) {
            var row = $(chks[nIndex]).parent().parent();
            var data = JSON.parse(chks[nIndex].value);

            if (index <= data.index) {
                row.before(newRow);
                break;
            }
            else {
                // Add to last position
                if (nIndex >= chks.length - 1) {
                    row.after(newRow);
                    break;
                }
                else {  // Between
                    var data1 = JSON.parse(chks[nIndex + 1].value);
                    if (index > data.index && index <= data1.index) {
                        row.after(newRow);
                        break;
                    }
                    else {
                        // Nothing
                    }
                }
            }
            
        } 
    }
    
    //$('#grid tr:last').after(newRow);
    //$('#grid').append(newRow);
    
    //$('#grid tr:last').eq(index).after(newRow);
    */
}


/*
----------------------------------------------------------------------------
Event groups [ end ]
----------------------------------------------------------------------------
*/



/*
----------------------------------------------------------------------------
Setting dialog [start]
----------------------------------------------------------------------------
*/
$(function () {
    // $('#dlgConfirm').dialog({
        // autoOpen: false,
        // modal: true,
        // resizable: false,
        // width: 550,
        // height: 200,
        // minWidth: 550,
        // minHeight: 200
    // });


    $("#dspTitleNm").click(dspTitleNm_Click);
    $("#dspTitleNmKn").click(dspTitleNmKn_Click);
    $("#dspPubDt").click(dspPubDt_Click);

    // Check JP language and show title kana
    if (getCurrentLanguage() != Consts.ConstLanguage_Ja) {
        $("#dspTitleNmKn").hide();
        $("#dspTitleNmKn_Seperate").hide();
    }
    else {
        $("#dspTitleNmKn").show();
        $("#dspTitleNmKn_Seperate").show();
    }

    // LockScreen();
});



// Contains non-exist pages
var bookmark_errorPages;

// Contains non-exist content
var bookmark_errorContent;

// Contain contents
var collection_contents;

// Contain pages
var collection_pages;

/*
Check a content is error or not 
*/
function IsErrorContent(strContentId) {
    var isError = false;
    
    for (var nIndex = 0; nIndex < bookmark_errorContent.length; nIndex++) {
        if (strContentId == bookmark_errorContent[nIndex].contentid) {
            isError = true;
            break;
        }
    }
    return isError;
}

/*
Check a content is checked + ok 
*/
function IsOKCheckedContent(strContentId) {
    var isOK = false;

    for (var nIndex = 0; nIndex < collection_contents.length; nIndex++) {
        if (strContentId == collection_contents[nIndex].contentid) {
            isOK = true;
            break;
        }
    }
    return isOK;
}

/*
Check a page is error or not (error pages were checked before)
*/
function IsErrorPage(strContentId, strPageNo) {
    var isError = false;
    
    for (var nIndex = 0; nIndex < bookmark_errorPages.length; nIndex++) {
        if (strContentId == bookmark_errorPages[nIndex].contentid
           && strPageNo == bookmark_errorPages[nIndex].pageNo) {
            isError = true;
            break;
        }
    }
    return isError;
}
function AddErrorPage(strContentId, strPageNo) {
    var isFound = false;
    for (var nIndex = 0; nIndex < collection_pages.length; nIndex++) {
        if (collection_pages[nIndex].contentid == strContentId && collection_pages[nIndex].pageNo == strPageNo) {
            isFound = true;
        }
    }
    if (!isFound) {
        var onePair = { contentid: strContentId, pageNo: strPageNo };
        bookmark_errorPages.push(onePair);
    }
}
function AddContent(strContentId) {
    var isFound = false;
    for (var nIndex = 0; nIndex < collection_contents.length; nIndex++) {
        if (collection_contents[nIndex].contentid == strContentId) {
            isFound = true;
            break;
        }
    }
    // Add to bufer if it does not exist
    if(!isFound) {
        collection_contents.push({ contentid: strContentId });
    }
}


function SyncPages() {

    for (var nIndex = 0; nIndex < collection_contents.length; nIndex++) {
        // Get one content
        var oneContent = collection_contents[nIndex];

        var params = {
            sid: ClientData.userInfo_sid(),
            contentId: oneContent.contentid,
            thumbnailFlg: 0
        }
        var webContentPage;

        // Get all pages of content
        avwCmsApiSync(ClientData.userInfo_accountPath(), "webContentPage", 'GET', params,
                function (data) {
                    // Success
                    if (data.pages) {
                        webContentPage = data.pages;
                    }
                }, null);

        if (webContentPage) {
            if (webContentPage.length > 0) {
                var arrBookmarks = ClientData.BookMarkData();

                for (var nIndex1 = 0; nIndex1 < arrBookmarks.length; nIndex1++) {
                    // Get one bookmar entity
                    var oneBookMark = arrBookmarks[nIndex1];

                    // Found contentid
                    if (oneBookMark.contentid == oneContent.contentid) {
                        var isFoundPage = false;
                        for (var nIndex2 = 0; nIndex2 < webContentPage.length; nIndex2++) {
                            if (oneBookMark.pageNo == webContentPage[nIndex2].pageNo) {
                                // Found pageNo
                                isFoundPage = true;
                                break;
                            }
                        }

                        if (!isFoundPage) {
                            AddErrorPage(oneBookMark.contentid, oneBookMark.pageNo);
                        }
                    }
                }

            }
            else {  // webContentPage.length = 0
                var arrBookmarks = ClientData.BookMarkData();
                for (var nIndex1 = 0; nIndex1 < arrBookmarks.length; nIndex1++) {
                    // Get one bookmar entity
                    var oneBookMark = arrBookmarks[nIndex1];

                    if (oneBookMark.contentid == oneContent.contentid) {
                        AddErrorPage(oneBookMark.contentid, oneBookMark.pageNo);
                    }
                }
            }
        }
    }
}

/*
  event of changing language
*/
function changeLanguageCallBackFunction() {
    if (getCurrentLanguage() != Consts.ConstLanguage_Ja) {
        $("#dspTitleNmKn").hide();
        $("#dspTitleNmKn_Seperate").hide();
        $("#txtTitleNmKnAsc").hide();
        $("#txtTitleNmKnDesc").hide();
    }
    else {
        $("#dspTitleNmKn").show();
        $("#dspTitleNmKn_Seperate").show();
        if (ClientData.sortOpt_searchDivision() == 2) { // Kana
            if (ClientData.sortOpt_sortType() == 1) {   // ASC
                $("#txtTitleNmKnAsc").show();
            }
            else {
                $("#txtTitleNmKnDesc").show();
            }
        }
    }
    document.title = i18nText('dspShiori') + ' | ' + i18nText('sysAppTitle');
}
/*
Synchronize bookmark with server
. Check existence of content
-> Delete absence content in local

. Check existence of pages
-> Delete absence pages in local
*/
function SyncContent() {

    // Reset error pages
    bookmark_errorPages = [];
    // Reset error contents
    bookmark_errorContent = [];

    // Reset array of pages
    collection_pages = [];

    collection_contents = [];

    // Get bookmarks from local storage
    var arrBookmarks = ClientData.BookMarkData();

    for (var nIndex = arrBookmarks.length - 1; nIndex >= 0; nIndex--) {

        var oneBookMark = arrBookmarks[nIndex];
        // ==================================
        // Check existence of content [start]
        // ==================================
        if (IsErrorContent(oneBookMark.contentid) == false) {
            // If content is ok + checked
            if (IsOKCheckedContent(oneBookMark.contentid) == false) {
                if (!IsExistContent(oneBookMark.contentid)) {
                    // Add to list of error content
                    bookmark_errorContent.push({ contentid: oneBookMark.contentid });
                    // Remove bookmark
                    arrBookmarks.splice(nIndex, 1);
                    ClientData.isChangedBookmark(true);
                }
                // ==================================
                // Check existence of content [ end ]
                // ==================================
                else {
                    // Add nromal content
                    AddContent(oneBookMark.contentid);
                }
            }
        }
        else {
            // Skip this case
        }
    }

    // Set back to storage
    ClientData.BookMarkData(arrBookmarks);

    // Call sync pages
    //SyncPages();
}

/*
Check content whether existed or not
*/
function IsExistContent(strContentId) {
    var isExisted = false;
    var params = {
        sid: ClientData.userInfo_sid(),
        getType: '1',
        contentId: strContentId
    }
    avwCmsApiSync(ClientData.userInfo_accountPath(), "webGetContent", 'GET', params,
                function (data) {
                    isExisted = true;
                },
                function (xmlHttpRequest, txtStatus, errorThrown) {
                    if (xmlHttpRequest.status == 404) {
                        isExisted = false;
                    }
                });
    return isExisted;
}

/*
----------------------------------------------------------------------------
Setting dialog [ end ]
----------------------------------------------------------------------------
*/

function truncate(strInput, length){
    if (strInput.length <= length)
    {
        return strInput;
    }
    else
    {
        return strInput.substring(0, length) + "...";
    }
}
